#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> t(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = {a[i], t[i]};
    }
    sort(v.begin(), v.end());
    ll l = 1;
    ll r = 100;
    while (l + 1 < r) {
        ll mid = (l + r) / 2;
        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            ll x = mid - v[i].first;
            if (x < 0) {
                continue;
            } else {
                x -= v[i].second;
                if (x >= 0) {
                    sum += pow(2, x + 1);
                } else {
                    sum++;
                }
            }
        }
        if (sum == m) {
            cout << mid;
            return 0;
        } else if (sum < m) {
            l = mid;
        } else {
            r = mid;
        }
    }
    cout << -1;
    return 0;
}